const EVENTS = [
	// DEFAULT PROD - Motorsports - Motul Petit Le Mans - 10/9/2024-10/12/2024
	{
		// urlHostName: "local-test",
		urlHostName: "www.hyundainsurvey.com",
		urlPathName: null,
		id: "113351",
		type: "motorsports",
		customWrapperClassName: "wrapper_motorsports",
		customStart: true,
		customRegistration: false,
		customThanks: false,
	},
	// MOTORSPORTS DEV - TEST EVENT
	{
		urlHostName: "hyundai-motorsports.smartactivatordev.com",
		// urlHostName: "local-test",
		urlPathName: null,
		id: "72371",
		type: "motorsports",
		customWrapperClassName: "wrapper_motorsports",
		customStart: false,
		customRegistration: false,
		customThanks: false,
	},
	// DEFAULT PROD - *INNOCEAN* - Liga MX – Fieston Phoenix - 11/09/2024	11/09/2024
	{
		// urlHostName: "local-test",
		urlHostName: "www.hyundaieventsurvey.com",
		urlPathName: null,
		id: "112656",
		type: "default",
		customWrapperClassName: null,
		customStart: null,
		customRegistration: false,
		customThanks: false,
	},
	// DEFAULT DEV - TEST EVENT
	{
		// urlHostName: "local-test",
		urlHostName: "hyundai-default.smartactivatordev.com",
		urlPathName: null,
		id: "75427",
		type: "default-custom",
		customWrapperClassName: null,
		customStart: true,
		customRegistration: false,
		customThanks: false,
	},
	// DEFAULT PROD - *INNOCEAN* - Electrify Expo - New York - 10/12/24-10/13/24
	{
		// urlHostName: "local-test",
		urlHostName: "www.hmaelectrifytour.com",
		urlPathName: null,
		id: "106324",
		type: "default",
		customWrapperClassName: null,
		customStart: null,
		customRegistration: false,
		customThanks: false,
	},
	// DEFAULT PROD - GRIDLIFE VIP Ticket Sweepstakes powered by Hyundai N
	{
		// urlHostName: "local-test",
		urlHostName: "www.hyundainsweeps.com",
		urlPathName: null,
		id: "95225",
		type: "default",
		customWrapperClassName: "wrapper_n-sweeps",
		customStart: true,
		customRegistration: true,
		customThanks: true,
	},
	// DEFAULT PROD - National Salute to America’s Heroes (5/27/2023 - 5/28/2023)
	{
		// urlHostName: "local-test",
		urlHostName: "www.hyundaisalute.com",
		urlPathName: null,
		id: "105242",
		type: "default",
		customWrapperClassName: "wrapper_salute",
		customStart: true,
		customRegistration: false,
		customThanks: false,
	},
	// DEFAULT PROD - Aviation Nation 2022 - Nellis Air Force Base
	{
		urlHostName: "www.hyundaiexperiential.com",
		urlPathName: null,
		id: "88901",
		type: "default",
		customStart: null,
		customWrapperClassName: null,
		customThanks: false,
	},
	// DEFAULT PROD - Daytime Stage at the iHeartRadio Music Festival
	{
		urlHostName: "www.hyundaieventsurvey1.com",
		urlPathName: null,
		id: "98326",
		type: "default",
		customStart: null,
		customWrapperClassName: null,
		customThanks: false,
	},
	// DEFAULT PROD - Rams Training Cam ( 7/28/2022	8/10/2022 )
	{
		urlHostName: "www.hyundairamstcactivations.com",
		urlPathName: null,
		id: "85269",
		type: "default",
		customStart: null,
		customWrapperClassName: "wrapper_rams",
		customThanks: false,
	},
	// SWEEPS DEV - TEST EVENT no active setup
	{
		urlHostName: "hyundai-electrify.smartactivatordev.com",
		urlPathName: null,
		id: null,
		type: "sweeps",
		customStart: true,
		customWrapperClassName: "wrapper_alt-fuel",
		customThanks: false,
	},
	// SWEEPS DEV - MARINE CORPS TEST EVENT
	{
		urlHostName: "hyundai-marine.smartactivatordev.com",
		urlPathName: null,
		id: "75425",
		type: "sweeps",
		customStart: true,
		customWrapperClassName: null,
		customThanks: false,
	},
	// SWEEPS PROD - MARINE CORPS
	{
		urlHostName: "www.hyundaihockeyexperience.com",
		urlPathName: null,
		id: "77321",
		type: "sweeps",
		customStart: true,
		customWrapperClassName: null,
		customThanks: false,
	},
	// MOTORSPORTS PROD - Laguna Seca N Performance Academy
	{
		urlHostName: "www.hyundainperformanceacademy.com",
		urlPathName: null,
		id: "80078",
		type: "motorsports",
		customStart: true,
		customWrapperClassName: "wrapper_motorsports",
		customThanks: false,
	},
	// DEFAULT DEV - DISNEY TEST EVENT
	{
		urlHostName: "hyundai-disney.smartactivatordev.com",
		urlPathName: null,
		id: "77013",
		type: "default",
		customStart: false,
		customWrapperClassName: "wrapper_disney",
		customThanks: true,
	},
	// DISNEY PROD - DISNEY
	{
		urlHostName: "www.hyundai25doc.com",
		urlPathName: null,
		id: "77239",
		type: "default",
		customStart: false,
		customWrapperClassName: "wrapper_disney",
		customThanks: true,
	},
];

var MODEL = {
	activeEvent: null,
	getEventID: function () {
		console.log("GET EVENT ID");

		let id = "";

		if (document.getElementById("bodyData")) {
			id = document.getElementById("bodyData").getAttribute("data-event-id");

			if (id.includes("{")) {
				id = "";
			}
		}

		console.log("ID: ", id);
		console.log("ID Length: ", id.length);

		MODEL.getUrlName(id);
	},
	getUrlName: function (id) {
		console.log("GET URL NAME");
		var urlName = null;

		if (id.length < 2) {
			urlName = window.location.hostname;

			console.log("URL NAME:", urlName);

			if (urlName === "localhost") {
				urlName = "local-test";
				console.log("LOCAL DEV", urlName);
			}

			MODEL.setActiveEvent(urlName, id);
		} else {
			urlName = "";
			MODEL.setActiveEvent(urlName, id);
		}
	},
	setActiveEvent: function (name, id) {
		EVENTS.forEach(function (event) {
			if (event.urlHostName === name || event.id === id) {
				MODEL.activeEvent = event;

				console.log("ACTIVE EVENT TYPE", MODEL.activeEvent.type);

				MODEL.setCustomStart();
				MODEL.setCustomRegistration();
				MODEL.setCustomThanks();
				MODEL.setSweeps();
				MODEL.setCustomStartQuestion();
			}
		});
	},
	setCustomStart: function () {
		console.log("SET CUSTOM START");
		if (MODEL.activeEvent.customStart && document.title === "Hyundai | Start") {
			if (MODEL.activeEvent.customWrapperClassName) {
				$("#customWrapper").addClass(MODEL.activeEvent.customWrapperClassName);
				$("#customWrapper > .main").hide();
			} else {
				$("#customWrapper > .header").addClass("js-hide-view");
			}

			if (MODEL.activeEvent.type === "motorsports") {
				$("#customWrapper").html("");
				$("#customWrapper").append(motorsportStartTemplate);
				$("#customWrapper").addClass("start");
				// $("#sweepsWrapper > form").html("");
			}

			if (MODEL.activeEvent.type === "default") {
				$("#sweepsWrapper > form").html("");
				$("#customWrapper > .header").addClass("js-hide-view");

				if (MODEL.activeEvent.customWrapperClassName === "wrapper_disney") {
					console.log("SET CUSTOM START - DISNEY");
					$("#customWrapper > .main").append(`
									<h2 style="color: #03aad2; text-align: center;font-family: 'HyundaiSansHead-Bold', Arial, sans-serif; margin-top: 3rem;">Complete this brief survey for your complimentary gift.</h2>
									<p style="color: #03aad2; text-align: center;font-family: 'HyundaiSansHead-Bold', Arial, sans-serif;">*Limited while supplies last.</p>
								`);
				}

				if (MODEL.activeEvent.customWrapperClassName === "wrapper_rams") {
					console.log("SET CUSTOM START - RAMS");
					$("#variableLogo").attr("src", "https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/4bde0f69-b172-49fd-be2a-8351cd3f461a/logo-rams.png");
					$("#variableLogo").css("width", "75%");
				}

				if (MODEL.activeEvent.customWrapperClassName === "wrapper_n-sweeps") {
					console.log("SET CUSTOM START - N Sweeps");
					$("#customWrapper > .main").show();
					$("html").css("background-color", "#aacae6");
					if (document.getElementById("customWrapper")) {
						document.getElementById("customWrapper").innerHTML = "";
						$("#customWrapper").append(
							/* html*/
							`
					<header class="header">
						<div class="logo">
							<img class="logo__image" src="https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/62fc4243-b87b-41e7-94d1-8b36d0b27df0/logo-n-sweeps.png" alt="" />
						</div>

						<div id="sweepsCopyHeader" class="n-sweeps-copy">
							<h3>About GRIDLIFE</h3>
							<p>GRIDLIFE is a grassroots motorsports event and lifestyle brand that is dedicated to inclusion
							 and focused on having fun in and around cars. They celebrate the full spectrum of car culture,
							 and package it up in a festival environment where good music and good times bring everyone together.
							 GRIDLIFE events feature activities such as road racing, time attack, drifting, car shows and concerts
							 in top markets.  To learn more about GRIDLIFE
							 <a style="color:#000;" href="https://www.grid.life/" target="_blank">click here</a>.
							 </p>
						</div>
					</header>

					<main class="main">
						<div id="sweepsCopyMain" class="n-sweeps-copy">
							<h3>About GRIDLIFE</h3>
							<p>GRIDLIFE is a grassroots motorsports event and lifestyle brand that is dedicated to inclusion
							 and focused on having fun in and around cars. They celebrate the full spectrum of car culture,
							 and package it up in a festival environment where good music and good times bring everyone together.
							 GRIDLIFE events feature activities such as road racing, time attack, drifting, car shows and concerts
							 in top markets.  To learn more about GRIDLIFE
							 <a style="color:#000;" href="https://www.grid.life/" target="_blank">click here</a>.
							 </p>
						</div>

						<div class="n-sweeps-hero">
							<picture>
								<source media="(orientation: portrait)" srcset="https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/62fc4243-b87b-41e7-94d1-8b36d0b27df0/image-hero-n-sweeps-landscape.jpg">
								<source media="(orientation: landscape)" srcset="https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/62fc4243-b87b-41e7-94d1-8b36d0b27df0/image-hero-n-sweeps-landscape.jpg">
								<img class="" src="https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/62fc4243-b87b-41e7-94d1-8b36d0b27df0/image-hero-n-sweeps-landscape.jpg" alt="N Line hero image" />
							</picture>

							<div class="info">
								<div class="info__block">
									<div class="info__title">
										<p>Events</p>
									</div>

									<p class="info__text">
										As the official automotive sponsor of GRIDLIFE, Hyundai will be randomly
										selecting 8 winners to receive two VIP tickets to the GRIDLIFE event of their choice.
										Events are <a style="color:#000;" href="https://www.grid.life/events" target="_blank">listed here</a>.
									</p>

								</div>

								<div class="info__block">
									<div class="info__title">
										<p>Rules</p>
									</div>

									<p class="info__text">
										The sweepstakes closes on August 10, 2023.
									</p>

									<p class="info__text">
										For official rules, please <span id="nSweepsRules">click here</span>.
									</p>
								</div>
							</div>

							<div class="info info_second">
								<div class="info__block">

									<div id="sweepsWrapper" class="row ">
										<form id="mozeus" name="mozeus" class="form" action="" onsubmit="return stopSubmit()">

											<div class="form__checkbox-wrapper">
												<input class="form__input-checkbox" type="checkbox" id="OptIn" data-id="OptIn" name="OptIn"
													value="Yes">
												<label class="form__label-checkbox" for="OptIn">By checking this box, I agree to enter the GRIDLIFE VIP Ticket Sweepstakes powered by Hyundai N and agree to the Official Rules.</label>
											</div>
										</form>
									</div>
								</div>

								<div class="info__block">

									<button id="sweepsStartButton" class="button">
                						Click Here to Enter Sweepstakes
            						</button>
								</div>
							</div>

						</div>
					</main>

					<footer class="footer">
						<img class="n-logo" src="https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/62fc4243-b87b-41e7-94d1-8b36d0b27df0/logo-hyundaiN.png" alt="" />
					</footer>
					`
						);

						setTimeout(function () {
							console.log("show logo");
							$("#customWrapper > .header").removeClass("js-hide-view");
							document.querySelector("#nSweepsRules").addEventListener("click", () => {
								document.getElementById("nRulesModal").classList.remove("modal_hidden");
							});

							document.querySelector("#closeNRules").addEventListener("click", () => {
								document.getElementById("nRulesModal").classList.add("modal_hidden");
							});

							buttonClick("#sweepsStartButton", getData_SweepsMandatory);

							// console.log("mandat")
							// if (utilities.validateCheckboxInputByName("OptIn")) {
							// 	DATA_START.sweeps = BuildResult(this.document, "mozeus");
							// 	console.log(DATA_START.sweeps);

							// 	advance();
							// } else {
							// 	$(".form__label-checkbox").addClass("mz-invalid-color")
							// }

							buttonClick("#sweepsStartButton", function () {
								console.log("mandat");
								if (utilities.validateCheckboxInputByName("OptIn")) {
									DATA_START.sweeps = BuildResult(this.document, "mozeus");
									console.log(DATA_START.sweeps);

									// advance();
									console.log("ADVANCE");
									window.scrollTo(0, 0);
									const activeWrapper = $(".wrapper_active-grid");
									const nextWrapper = activeWrapper.nextAll(".wrapper")[0];

									activeWrapper.removeClass("wrapper_active-grid");
									activeWrapper.removeClass("wrapper_active");
									nextWrapper.classList.add("wrapper_active");

									window.scrollTo(0, 0);
								} else {
									$(".form__label-checkbox").addClass("mz-invalid-color");
								}
								// DATA_START.sweeps = BuildResult(this.document, "mozeus");
								// console.log(DATA_START.sweeps);

								// console.log("ADVANCE");
								// window.scrollTo(0, 0);
								// const activeWrapper = $(".wrapper_active");
								// const nextWrapper = activeWrapper.nextAll(".wrapper")[0];

								// activeWrapper.removeClass("wrapper_active-grid");
								// activeWrapper.removeClass("wrapper_active");
								// nextWrapper.classList.add("wrapper_active");

								// window.scrollTo(0, 0);
							});

							$("#customWrapper").addClass("wrapper_active-grid");
						}, 500);
					}
				}

				if (MODEL.activeEvent.customWrapperClassName === "wrapper_salute") {
					console.log("SET CUSTOM START - Salute");
					$("#customWrapper > .main").show();

					if (document.getElementById("customWrapper")) {
						document.getElementById("customWrapper").innerHTML = "";
						$("#customWrapper").append(
							/* html*/
							`
						<header class="header">

						</header>

						<main class="main">
							<div class="logo">
							<picture>
								<source srcset="https://smartactivator.blob.core.windows.net/saassets/3583f7c2-b1c4-4718-b24d-a78e9628f6e5/62fc4243-b87b-41e7-94d1-8b36d0b27df0/logo-salute.png">
								<img id="variableLogo" class="logo__image" src="logo-salute.png" alt="N Line hero image" />
							</picture>
							</div>


							<div class="button-wrapper">
								<button id="startButton" class="button button_large">
									Click here to begin
								</button>
							</div>
						</main>

						<footer class="footer">
							<div id="sweepsWrapper" class="row js-hide-view">
								<form id="mozeus" name="mozeus" class="form" action="" onsubmit="return stopSubmit()">

									<div class="form__checkbox-wrapper">
										<input class="form__input-checkbox" type="checkbox" id="OptIn" data-id="OptIn" name="OptIn" value="Yes">
										<label class="form__label-checkbox" for="OptIn">I agree to enter the <span class="optinSweeps">Hyundai Sweepstakes</span></label>
									</div>
								</form>
							</div>
						</footer>
					`
						);

						// setTimeout(function () {
						// 	console.log("show logo")
						// 	$("#customWrapper > .header").removeClass("js-hide-view");

						// 	buttonClick('#startButton', function () {
						// 		DATA_START.sweeps = BuildResult(this.document, "mozeus");
						// 		console.log(DATA_START.sweeps);

						// 		console.log("ADVANCE");
						// 		window.scrollTo(0, 0);
						// 		const activeWrapper = $(".wrapper_active");
						// 		const nextWrapper = activeWrapper.nextAll(".wrapper")[0];

						// 		activeWrapper.removeClass("wrapper_active-grid");
						// 		activeWrapper.removeClass("wrapper_active");
						// 		nextWrapper.classList.add("wrapper_active");

						// 		window.scrollTo(0, 0);
						// 	});

						// 	$("#customWrapper").addClass("wrapper_active-grid");
						// }, 500)
					}
				}
			}

			setTimeout(function () {
				console.log("show wrapper TIMEOU");
				$("#customWrapper").addClass("wrapper_active");
			}, 500);
		} else {
			console.log("NO CUSTOM START");
			if (!MODEL.activeEvent.customStart) {
				if (document.getElementById("customWrapper")) {
					document.querySelector(".header").style.opacity = "0";
					document.getElementById("customWrapper").classList.add("wrapper_active");
				}
			}
		}
	},
	setCustomRegistration: function () {
		if (MODEL.activeEvent.customRegistration && document.title === "Hyundai | Registration") {
			console.log("SET CUSTOM REGISTRATION");

			if (MODEL.activeEvent.customWrapperClassName === "wrapper_n-sweeps") {
				document.getElementById("rateOverallOpinion").style.display = "none";
				document.getElementById("rateEventOpinion").style.display = "none";

				console.log("Land", language);

				setTimeout(function () {
					function validate_OpinionQuestions() {
						var radios = surveyQuestionsValidate("changedHyundaiOpinion", "purchaseOnExperience");

						return radios;
					}

					function getData_OpinionQuestions() {
						if (validate_OpinionQuestions()) {
							DATA_REGISTRATION.opinionQuestions = BuildResult(this.document, "mozeus-opinion-questions");

							console.log(DATA_REGISTRATION);

							if (!app.model.dealerContactsAvailable) {
								// document.getElementById('optInWrap').style.display = "none";
								getData_DealerContact();
							} else {
								advance();
							}
						}
					}

					buttonClick("#cont4", getData_OpinionQuestions);

					console.log("timed out");
					if (language === "English") {
						document.getElementById("changedHyundaiOpinionCopy").innerText =
							"Now that you are aware that Hyundai is a sponsor of GRIDLIFE, please tell us if your opinion of the Hyundai brand has changed.";
						document.getElementById("purchaseOnExperienceCopy").innerText = "How likely are you to consider purchasing a Hyundai?";
					} else {
						document.getElementById("changedHyundaiOpinionCopy").innerText =
							"Ahora que está al tanto de que Hyundai es patrocinador de GRIDLIFE, díganos si ha cambiado su opinión sobre la marca Hyundai";
						document.getElementById("purchaseOnExperienceCopy").innerText = "¿Qué tan probable es que considere comprar un Hyundai?";
					}
				}, 3000);
			}
		}
	},
	setCustomThanks: function () {
		if (MODEL.activeEvent.customThanks && document.title === "Hyundai | Thanks") {
			if (MODEL.activeEvent.customWrapperClassName === "wrapper_n-sweeps") {
				let language = utilities.getConsumerLanguage("languagePull");
				if (language === "English") {
					$(".main_thanks").append(`
									<h3 style="color: #03aad2; text-align: center;font-family: 'HyundaiSansHead-Bold', Arial, sans-serif; margin-top: 3rem;">If you are a sweepstakes winner, we will contact you after August 10, 2023. </h3>
									<h3 style="color: #03aad2; text-align: center;font-family: 'HyundaiSansHead-Bold', Arial, sans-serif; margin-top: 1rem;">We will not be contacting those who are not selected. </h3>
								`);
				} else {
					$(".main_thanks").append(`
									<h3 style="color: #03aad2; text-align: center;font-family: 'HyundaiSansHead-Bold', Arial, sans-serif; margin-top: 3rem;">Si gana el sorteo, nos comunicaremos con usted después del 25 de agosto de 2023</h3>
									<h3 style="color: #03aad2; text-align: center;font-family: 'HyundaiSansHead-Bold', Arial, sans-serif; margin-top: 1rem;">No estaremos contactando a aquellos que no sean seleccionados. </h3>
								`);
				}
			}
		}
	},
	setSweeps: function () {
		if (MODEL.activeEvent.type === "sweeps") {
			$("#sweepsWrapper").removeClass("js-hide-view");
			$("#startButton").css("display", "none");
			$("#sweepsStartButton").css("display", "block");
		}
	},
	setCustomStartQuestion: function () {
		if (MODEL.activeEvent.type === "default-custom" && document.title === "Hyundai | Start") {
			$("#sweepsWrapper").removeClass("js-hide-view");
			$("#startButton").css("display", "none");
			$("#sweepsStartButton").css("display", "block");

			$("#sweepsWrapper > form").html(
				/* html*/
				`
		<section id="customQuestionSection" class="form__section">
					<label id="customQuestionLabel" class="form__label-text" for="CustomDataField">Guess how many soccer balls are in the trunk of one of the Hyundai SANTA FE for a chance to win a $500 gift card. / Adivina cuántos balones de fútbol hay en la cajuela de la Hyundai SANTA FE y tendrás la oportunidad de ganar una tarjeta de regalo de $500.
		  </label>
					<input class="form__input-text" id="CustomDataField" name="CustomDataField" type="tel" data-type="Number" minlength="1" data-min-length="1" maxlength="4" data-max-length="4" />
				</section>

				<div class="form__checkbox-wrapper">
		  <input class="form__input-checkbox" type="checkbox" id="OptIn" data-id="OptIn" name="OptIn" value="Yes">
				  <label class="form__label-checkbox" for="OptIn">
			By checking this box, I agree to the <span id="ligaMexRulesButton" style="text-decoration:underline;">Official Rules</span> and Hyundai&rsquo;s <a href="https://www.hyundaiusa.com/us/en/privacy-policy-page" target="_blank">Privacy Policy</a>. / Al marcar esta casilla, acepto las <span id="ligaMexRulesButton2" style="text-decoration:underline;">Reglas Oficiales</span>  y la <a href="https://www.hyundaiusa.com/us/en/privacy-policy-page" target="_blank">Política de Privacidad</a> de Hyundai.
		  </label>
		</div>

		`
			);

			setTimeout(() => {
				document.getElementById("ligaMexRulesButton").addEventListener("click", (e) => {
					e.preventDefault();
					e.stopPropagation();
					document.getElementById("ligaMexModal").classList.remove("modal_hidden");
				});

				document.getElementById("ligaMexRulesButton2").addEventListener("click", (e) => {
					e.preventDefault();
					e.stopPropagation();
					document.getElementById("ligaMexModalSpanish").classList.remove("modal_hidden");
				});

				document.querySelector(".closeMexModal").addEventListener("click", (e) => {
					e.preventDefault();
					e.stopPropagation();
					document.getElementById("ligaMexModal").classList.add("modal_hidden");
				});

				document.querySelector(".closeMexModalSpanish").addEventListener("click", (e) => {
					e.preventDefault();
					e.stopPropagation();
					document.getElementById("ligaMexModalSpanish").classList.add("modal_hidden");
				});
			}, 300);
		}
	},
};

window.addEventListener("DOMContentLoaded", function () {
	MODEL.getEventID();
});
